/*
 * Rotore.java
 *
 * Created on 7 marzo 2008, 19.22
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package enigma;

/**
 *
 * @author dario
 */
public class Rotore implements RicettoreInterface {
    
    /** Creates a new instance of Rotore */
    public Rotore(RicettoreInterface prev, int[] t, int p) {
        precedente = prev;
//        precedente = prev;
        tipo = t;
        posizione = p;
    }
    
    public void accettaLetteraAvanti(int lettera) {
        // Trovo la lettera mappata
//        System.out.println("\nAVANTI: Lettera in entrata = " + lettera);
        int letteraInUscita = (tipo[(lettera + posizione) % 26]); // % 26;
//        System.out.println("Lettera in uscita = " + letteraInUscita);
        // La invio al prossimo Ricettore
        prossimo.accettaLetteraAvanti(letteraInUscita);
        
    }
    
    public void accettaLetteraIndietro(int lettera) {
//        System.out.println("\nINDIETRO: Lettera in entrata = " + lettera);
        
        // Devo trovare l'inverso della lettera
        int letteraInUscita = 0;
        for (int i = 0; i < tipo.length; i ++) {
            if (tipo[i] == lettera) {
                letteraInUscita = i;
            }
        }
        
        letteraInUscita = letteraInUscita - posizione;
        
        if (letteraInUscita < 0) {
            letteraInUscita = 26 - (-letteraInUscita);
        }
        
//        System.out.println("Lettera in uscita = " + letteraInUscita);
        
        precedente.accettaLetteraIndietro(letteraInUscita);
    }
    
    public void segnaleGiro() {
        incrementaPosizione();
    }
    
    private void incrementaPosizione() {

            posizione = (posizione + 1) % 26;
        if (posizione == 0) {
            prossimo.segnaleGiro();
        }
    }

    public void impostaProssimo(RicettoreInterface r) {
        prossimo = r;
    }
    
    private RicettoreInterface prossimo;
    private RicettoreInterface precedente;
    private int[] tipo;
    private int posizione;    
}
